#include "X3D_SharedCoordComputer.h"
#include "X3D_SharedCoordComputerRenderingVisitor.h"
#include "DFSGraphTraversal.h"

namespace X3DTK {
namespace X3D {

SharedCoordComputer::SharedCoordComputer()
: X3DOnePassProcessor()
{
  stateVariables = GraphTraversal::getInstanceOf<SharedCoordComputerStateVariables>();
  
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new SharedCoordComputerRenderingVisitor());
}

SharedCoordComputer::~SharedCoordComputer()
{
  GraphTraversal::removeInstanceOf<SharedCoordComputerStateVariables>();

  delete graphTraversal;
}

void SharedCoordComputer::compute(SFAbstractNode N)
{
  graphTraversal->traverse(N);
  stateVariables->finish();
}


}
}
