#include "GraphTester.h"
#include "X3DAbstractNode.h"
#include "DFSGraphTraversal.h"
#include "GraphTesterAbstractVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {

GraphTester::GraphTester()
{
  stateVariables = GraphTraversal::getInstanceOf<GraphTesterStateVariables>();
  
  graphTraversal = new DFSGraphTraversal();
  
  graphTraversal->setComponentVisitor(new GraphTesterAbstractVisitor());
}

GraphTester::~GraphTester()
{
  GraphTraversal::removeInstanceOf<GraphTesterStateVariables>();
  
  delete graphTraversal;
}
  
void GraphTester::test(SFAbstractNode N) const
{
  cout << "testing " << N->getTypeName() << endl;
  stateVariables->init();
  graphTraversal->traverse(N);
}
  
}
