#include "Progress.h"

namespace X3DTK {

Progress::Progress(int step)
: _totalSteps(0), _progress(0), _step(step) 
{
}

void Progress::setTotalSteps(int totalSteps)
{
  _totalSteps = totalSteps;
  _inc = 0;
  RC::Route::send(this, &Progress::getTotalSteps);
}

void Progress::setProgress(int progress)
{
  _progress = progress;
  ++_inc;
  if (_inc == _step)
  {
    RC::Route::send(this, &Progress::getProgress);
    _inc = 0;
  }  
}

int Progress::getTotalSteps() const
{
  return _totalSteps;
}

int Progress::getProgress() const
{
  return _progress;
}

}
